#include <stdio.h>
#include "computation_graph.h"
#include "node_add.h"
#include "node_mult.h"
#include "node_constant.h"
#include "node_gain.h"

int main() {
    struct computation_graph *graph = create_graph();

    int const1 = graph_add_node_const(graph, "Const 1");
    graph_set_param_val(graph, const1, CONST_SET, 2);
    int const2 = graph_add_node_const(graph, "Const 2");
    graph_set_param_val(graph, const2, CONST_SET, 3);

    int add1_id = graph_add_node_add(graph, "Add");
    graph_set_source(graph, add1_id, ADD_SUMMAND1, const1, CONST_VAL);
    graph_set_source(graph, add1_id, ADD_SUMMAND2, const2, CONST_VAL);

    int gain1_id = graph_add_node_gain(graph, "Gain");
    graph_set_param_val(graph, gain1_id, GAIN_GAIN, 3);
    graph_set_source(graph, gain1_id, GAIN_INPUT, add1_id, ADD_SUM);

    int mult1_id = graph_add_node_mult(graph, "Mult");
    graph_set_source(graph, mult1_id, MULT_MULTIPLICAND1, gain1_id, GAIN_RESULT);
    graph_set_source(graph, mult1_id, MULT_MULTIPLICAND2, const1, CONST_VAL);

    graph_compute_node(graph, mult1_id);

    FILE* dot_fp;
    dot_fp = fopen("..\\comp_graph.dot", "w");
    export_dot(graph, dot_fp);
    fclose(dot_fp);
    printf("Sum is %f\n", graph_get_output(graph, mult1_id, GAIN_RESULT));
    fflush(stdout);
    return 0;
}
